// Generated by CoffeeScript 2.2.3
(function() {
  var color_vars, postcss, valueHook;

  postcss = require('postcss');

  valueHook = require('./value-hook');

  color_vars = {};

  valueHook.add(function(str, node) {
    try {
      return str.replace(/@([a-z_\-]+)/i, function(m, name) {
        if (color_vars[name]) {
          return valueHook.hook(color_vars[name], node);
        } else {
          return '#fff'
        }
      });
    } catch (e) {
      return '#fff';
    }

  });

  module.exports = postcss.plugin('gtk-color-variables', function() {
    return function(css, processor) {
      return css.walkAtRules(function(node) {
        var _, name, value;
        if (node.name === 'define-color') {
          [_, name, value] = node.params.match(/(\S+)\s+(.*)/);
          color_vars[name] = value;
          return node.remove();
        }
      });
    };
  });
}.call(this));
