// Generated by CoffeeScript 2.2.3
(function() {
  var postcss;

  postcss = require("postcss");

  module.exports = postcss.plugin("fix-font-declarations", function() {
    return function(css, processor) {
      var SIZE, WEIGHT;
      SIZE = /\d+(?:\.\d+)?(px|em|pt|pc|%|cm|mm|in|)/;
      WEIGHT = /bold|light|normal/i;
      css.walkDecls(function(decl) {
        var fontFamily, the_rest;
        if (decl.prop === "font") {
          if (decl.value !== "initial") {
            the_rest = decl.value.replace(SIZE, function(fontSize) {
              decl.parent.insertBefore(decl, {
                prop: "font-size",
                value: fontSize
              });
              return "";
            }).replace(WEIGHT, function(weight) {
              var fontWeight;
              fontWeight = weight.toLowerCase();
              if (fontWeight === "light") {
                fontWeight = "300";
              }
              decl.parent.insertBefore(decl, {
                prop: "font-weight",
                value: fontWeight
              });
              return "";
            });
            fontFamily = the_rest.trim();
            if (fontFamily) {
              decl.parent.insertBefore(decl, {
                prop: "font-family",
                value: '"' + fontFamily + '"'
              });
            }
            return decl.remove();
          }
        }
      });
      return css.walkDecls(function(decl) {
        if (decl.prop === "font-size") {
          if (decl.value !== "0") {
            let match = decl.value.match(SIZE);
            if (!match) {
              if (decl.value === 'smaller') {
                return decl.value = '9px';
              }
              return decl.value = '11px';
            }

            let [fontSize, unit] = match;
            if (!unit) {
              return decl.value = `${fontSize}pt`;
            }
          }
        }
      });
    };
  });


// @TODO: implement the rest of https://developer.gnome.org/pango/stable/pango-Fonts.html#pango-font-description-from-string
// Like how the documentation mentions STYLE_OPTIONS (and also STYLE-OPTIONS), which isn't in the given syntax? Fun.

}).call(this);
